;;; To be used with NeXT Scorefile Package Version 3

(require :scorefile)
(use-package 'scorefile)
(score examp12)
(header "
envelope bumps   = [(0,0)(.2,1)(.3 ,.5)|(.4,0.0)];
envelope ramp01 =  [(0,0)(.05,1)];
envelope ramp10 =  [(0,1)(.05,0)];
" )

(defun ranVowel () 
  (nth (floor (random 8.999))
   '("BA" "BE" "BO" "BU" "TA" "TE" "TI" "TO" "TU")))


(part nil	                        ; Generate names automatically
      ("DBWave2vi")
      '(0 10)		; Time specification
      :noteOn	
      (dt .1 :quiet)
      (timetag (accumulate-durs dt))
      (freq  '(* (eval g2) (exp (random 1.0) ))) 
      (ampEnv "bumps")
      (waveform0 
       '(if (= (notenum) 1) "BA" 
	  (cycle '((ranVowel) nil)))
	  :string)
      (waveform1 '(cycle '((ranVowel) nil))
		 :string)
      (waveformAtt '(pval dt))
      (waveformEnv '(cycle '("ramp01" "ramp10")))
      (freqEnv "ramp01")
      (freqAtt '(pval dt))
      (svibAmp .01)
      ;; Randomize vibrato frequencies a bit.
      (svibFreq (+ 4.5 (random 1.0)))
      (rvibAmp .008)
      )

(write-score examp12)
(play)
