/*	fixedPolicy - enable setting fixed priority scheduling from user progs
** From an example in the C functions chapter of the NeXT O.S.Software manual.
**	psl, 5/92
**
**fixedPolicy:	fixedPolicy.c
**	$(CC) $(CFLAGS) -object -s fixedPolicy.c -o $@
**	-rm  $(BINDIR)/$@
**	ln $@ $(BINDIR)/$@
**	chmod 4750 $(BINDIR)/$@
**	/etc/chown root $(BINDIR)/$@
**	@echo "I hope you ran this make as root..."
*/

/* Helpful comment from an almost identical program by David Jaffe:
**
**   This program must run as root. This means it must be owned by root
** and have the u+s bit set in its permission.  It needs to be run only
** once after each reboot (assuming no program DISables the fixed policy.
** No NeXT programs do this.) 
*/

#import <mach/mach.h>
#import <mach/mach_init.h>
#import <mach/mach_error.h>
#import	<mach/message.h>
#import <mach/cthreads.h>
#import <stdio.h>

#define	CME(m,e)	if((e)!=KERN_SUCCESS) {mach_error(m,e);exit(1);}

void
main(int argc, char *argv[])
{
	kern_return_t e;
	processor_set_t def_set, def_set_priv;

	/* Fix the default processor set to allow a fixed priority thread. */
	e = processor_set_default(host_self(), &def_set);
	CME("processor_set_default() failed", e);
	e = host_processor_set_priv(host_priv_self(), def_set, &def_set_priv);
	CME("host_processor_set_priv() failed", e);
	e = processor_set_policy_enable(def_set_priv, POLICY_FIXEDPRI);
	CME("processor_set_policy_enable() failed", e);
	exit(0);
}
