/* TunerApp.h -- copyright 1992 by C.D.Lane */

#import <appkit/appkit.h>
#import <soundkit/soundkit.h>
#import <musickit/musickit.h>

@interface TunerApp : Application
{
	id flat;
	id sharp;
	id attune;

	id sound;
	id sample;
	id version;
	
	id soundView;
	id soundMeter;

	id calibrationField;
	id calibrationMatrix;
	
	id transpositionField;
	id transpositionMatrix;
	
	id buttonMatrix;
	id methodMatrix;
	
	id centSlider;
	id timeSlider;
	id squelchSlider;
	id toleranceSlider;
	id adjustmentSlider;

	id helpScrollView;

	id defaults;
	NXBundle *bundle;
	MKKeyNum key, lastKey;
	DPSTimedEntry timedEntry;
	double frequency, amplitude;
}

+ new;

- appDidInit:sender;
- appWillTerminate:sender;
- free;

- willRecord:sender;
- didRecord:sender;

- openHelpPanel:sender;

- computeFrequency;
- computeFrequencyViaFFT;

- showNoteName;
- clearNoteName;

- showCentError;
- clearCentError;

- switchMethod:(const char *) reason;

- setDefault:sender;
- setCalibration:sender;
- setTransposition:sender;

- printf:(const char *) format, ...;

- loadDefaults:sender;
- saveDefaults:sender;
- resetDefaults:sender;

- setVersion:anObject;

@end
